const handlers = require('./handlers')

module.exports = [
    {
        method: 'getAgentes',
        handler: handlers.getAgentes,
        options: {
            description: 'Adiciona um agente em uma ou mais filas',
            log: false
        }
    },
    {
        method: 'AdicionarAgente',
        handler: handlers.AdicionarAgente,
        options: {
            description: 'Adiciona um agente em uma ou mais filas',
            validade: ['ramal', 'fila', 'nome'],
            log: false
        }
    },
    {
        method: 'RemoverAgente',
        handler: handlers.RemoverAgente,
        options: {
            description: 'Remove um agente em uma ou mais filas',
            validade: ['ramal', 'fila'],
            log: false
        }
    },
    {
        method: 'PausarAgente',
        handler: handlers.PausarAgente,
        options: {
            description: 'Pausa um agente em todas as filas',
            validade: ['ramal'],
            log: false
        }
    },
    {
        method: 'TirarPausaAgente',
        handler: handlers.TirarPausaAgente,
        options: {
            description: 'Despausa um agente em todas as filas',
            validade: ['ramal'],
            log: false
        }
    }
]