const { ami } = require('../../../index')
const log = require("node-live-log")("ami/Metodos/Fila");

exports.monitorar_filas = async (socket) => {
    socket.filas.forEach(fila => {
        socket.join(`fila_${fila}`);
    });
    return { error: false, msg: 'Monitor iniciando', filas: socket.filas }
}

exports.getFilas = async (socket, request) => {
    log.debug('getFilas REQUEST: ', request)
    try {
        const allFilas = ami.getFilas();
        // log.debug('ami.getFilas RETORNO: ', allFilas)
        let filas = allFilas.filter(f => socket.filas.includes(f.nome));
        // log.debug('Filas do usuário: ', socket.filas)
        // log.debug('getFilas filtrado: ', filas)
        if (request && request.fila) {
            if (Array.isArray(request.fila)) {
                filas = filas.filter(f => request.fila.includes(f.nome));
            }
            else {
                filas = filas.filter(f => f.nome == request.fila);
            }
        }
        return filas;
    } catch (error) {
        log.error('getFilas ERROR: ', error)
    }
}

exports.adionarLigacaoNaFila = async (socket, request) => {
    log.debug('adionarLigacaoNaFila REQUEST: ', request)
    try {
        ami.adionarLigacaoNaFila(request)
        return { error: false, msg: 'Ligação adicionada na fila' }
    } catch (error) {
        log.error('adionarLigacaoNaFila ERROR: ', error)
    }
}

exports.abandonarLigacaoNaFila = async (socket, request) => {
    log.debug('abandonarLigacaoNaFila REQUEST: ', request)
    try {
        ami.abandonarLigacaoNaFila(request)
        return { error: false, msg: 'Ligação abandonada na fila' }
    } catch (error) {
        log.error('abandonarLigacaoNaFila ERROR: ', error)
    }
}

exports.atenderLigacaoNaFila = async (socket, request) => {
    log.debug('atenderLigacaoNaFila REQUEST: ', request)
    try {
        ami.atenderLiacaoNaFila(request)
        return { error: false, msg: 'Ligação atendida na fila' }
    } catch (error) {
        log.error('atenderLigacaoNaFila ERROR: ', error)
    }
}

exports.desligarLigacaoNaFila = async (socket, request) => {
    log.debug('desligarLigacaoNaFila REQUEST: ', request)
    try {
        ami.desligarLigacaoNaFila(request)
        return { error: false, msg: 'Ligação desligada na fila' }
    } catch (error) {
        log.error('desligarLigacaoNaFila ERROR: ', error)
    }
}