const handlers = require('./handlers')

module.exports = [
    {
        method: 'monitorar_filas',
        handler: handlers.monitorar_filas,
        options: {
            description: 'Coloca o socket em modo de monitoramento de filas',
            log: false
        }
    },
    {
        method: 'getFilas',
        handler: handlers.getFilas,
        options: {
            description: 'Obtem os dados das filas que o socket tem permissão',
            log: false
        }
    },
    {
        method: 'adicionarLigacaoNaFila',
        handler: handlers.adionarLigacaoNaFila,
        options: {
            description: 'Adiciona uma ligação na fila',
            validade: ['queue', 'linkedid', 'calleridnum', 'calleridname', 'position', 'count'],
            log: false
        }
    },
    {
        method: 'abandonarLigacaoNaFila',
        handler: handlers.abandonarLigacaoNaFila,
        options: {
            description: 'Abandona uma ligação na fila',
            validade: ['queue', 'linkedid', 'position'],
            log: false
        }
    },
    {
        method: 'atenderLigacaoNaFila',
        handler: handlers.atenderLigacaoNaFila,
        options: {
            description: 'Atende uma ligação na fila',
            validade: ['queue', 'linkedid', 'membername', 'interface', 'ringtime'],
            log: false
        }
    },
    {
        method: 'desligarLigacaoNaFila',
        handler: handlers.desligarLigacaoNaFila,
        options: {
            description: 'Desliga uma ligação na fila',
            validade: ['queue', 'linkedid', 'membername', 'interface', 'reason', 'talktime'],
            log: false
        }
    },
]