const handlers = require('./handlers')

module.exports = [
    {
        method: 'Discar',
        handler: handlers.Discar,
        options: {
            description: 'Retorna todas as ligações ativas',
            validate: ['origem', 'destino', 'rota'],
            log: false
        }
    },
    {
        method: 'Conferencia',
        handler: handlers.Conferencia,
        options: {
            description: 'Efetua uma conferência entre ligações ativas',
            validate: ['sala', 'destino', 'rota'],
            log: false
        }
    },
    {
        method: 'Desligar',
        handler: handlers.Desligar,
        options: {
            description: 'Desliga uma ligação ativa',
            log: false
        }
    }
]