const handlers = require('./handlers');

module.exports = [
    {
        method: 'login_adm',
        handler: handlers.login_adm,
        options: {
            description: 'Realiza o login de um usuário administrador',
            validade: ['nome', 'senha'],
            auth: false,
            log: false
        }
    },
    {
        method: 'login_adm_token',
        handler: handlers.login_adm_token,
        options: {
            description: 'Realiza o login de um usuário administrador via token',
            validade: ['nome', 'token'],
            auth: false,
            log: false
        }
    },
    {
        method: 'login_adm_ldap',
        handler: handlers.login_adm_ldap,
        options: {
            description: 'Realiza o login de um usuário administrador via LDAP',
            validade: ['nome', 'session_id'],
            auth: false,
            log: false
        }
    },
    {
        method: 'login_agente',
        handler: handlers.login_agente,
        options: {
            description: 'Realiza o login de um agente',
            validade: ['nome', 'senha'],
            auth: false,
            log: false
        }
    },
    {
        method: 'login_agente_web',
        handler: handlers.login_agente_web,
        options: {
            description: 'Realiza o login de um agente via token',
            validade: ['token'],
            auth: false,
        }
    },
    {
        method: 'login_api',
        handler: handlers.login_api,
        options: {
            description: 'Realiza o login de um usuário administrador via API',
            auth: false,
            log: false
        }
    }
]