module.exports = class FilaAmi {
    /**
    * @typedef fila
    * @type {object}
    * @property {number} id - Identificador da fila
    * @property {string} nome - Nome da fila
    */
    /**
     * Representação dos dados do agente dentro do Ami.
     * @param {fila} fila
     */
    constructor(fila) {
        Object.assign(this, fila)
    }
    static get AtributosMap() {
        return new Map([
            ["id", "id"],
            ["nome", "no"],
            ["ramal", "ra"],
            ["fila", "fl"],
            ["fila_padrao", "fp"],
            ["pausa", "pa"],
            ["pausa_motivo", "pm"],
            ["max_chat_atende", "ma"],
            ["status", "st"],
            ["status_date", "sd"],
            ["ligacoes_efetuadas", "le"],
            ["ligacoes_recebidas", "lr"],
            ["ligacoes_naoatendidas", "ln"],
            ["ligacoes_naocompletadas", "lp"]
        ]);
    }
    static getChavePeloValor(val) {
        return [...FilaAmi.AtributosMap].find(([key, value]) => val === value)[0];
    }
}