"use strict";
var __awaiter = (this && this.__awaiter) || function (thisArg, _arguments, P, generator) {
    function adopt(value) { return value instanceof P ? value : new P(function (resolve) { resolve(value); }); }
    return new (P || (P = Promise))(function (resolve, reject) {
        function fulfilled(value) { try { step(generator.next(value)); } catch (e) { reject(e); } }
        function rejected(value) { try { step(generator["throw"](value)); } catch (e) { reject(e); } }
        function step(result) { result.done ? resolve(result.value) : adopt(result.value).then(fulfilled, rejected); }
        step((generator = generator.apply(thisArg, _arguments || [])).next());
    });
};
Object.defineProperty(exports, "__esModule", { value: true });
const knorm_1 = require("@knorm/knorm");
class KnormTimestamps {
    constructor({ createdAt = {}, updatedAt = {}, name = 'timestamps' } = {}) {
        this.name = name;
        this.fields = {};
        this.fields[createdAt.name || 'createdAt'] = {
            type: 'dateTime',
            column: createdAt.column || 'created_at',
            default: () => new Date(),
            updated: false,
        };
        this.updatedAtFieldName = updatedAt.name || 'updatedAt';
        this.fields[this.updatedAtFieldName] = {
            type: 'dateTime',
            column: updatedAt.column || 'updated_at',
            default: () => new Date(),
        };
    }
    updateModel(knorm) {
        class TimestampsModel extends knorm.Model {
        }
        TimestampsModel.fields = this.fields;
        knorm.updateModel(TimestampsModel);
    }
    updateQuery(knorm) {
        const { updatedAtFieldName } = this;
        class TimestampsQuery extends knorm.Query {
            update(data, options) {
                const _super = Object.create(null, {
                    update: { get: () => super.update }
                });
                return __awaiter(this, void 0, void 0, function* () {
                    if (data) {
                        (Array.isArray(data) ? data : [data]).forEach((data) => {
                            data[updatedAtFieldName] = new Date();
                        });
                    }
                    return _super.update.call(this, data, options);
                });
            }
        }
        knorm.updateQuery(TimestampsQuery);
    }
    init(knorm) {
        if (!knorm) {
            throw new this.constructor.KnormTimestampsError('no Knorm instance provided');
        }
        if (!(knorm instanceof knorm_1.Knorm)) {
            throw new this.constructor.KnormTimestampsError('invalid Knorm instance provided');
        }
        this.updateModel(knorm);
        this.updateQuery(knorm);
    }
}
exports.KnormTimestamps = KnormTimestamps;
KnormTimestamps.KnormTimestampsError = class KnormTimestampsError extends knorm_1.Knorm.KnormError {
};
