# Xcontact Lib
Modulo JS para bibliotecas comuns do Xcontact

## Instalação
```bash
$ yarn add http://git.xcontactcenter.com:3000/X5Solucoes/xcontact-lib/archive/1.0.tar.gz
```

## Configuração
A lib usa as seguintes váriaveis `process.env` que você pode definir como variável de ambiente do sistema operacional ou direto no projeto antes de importar a lib.

* `process.env.PGHOST`: (string) IP ou nome do servidor de banco de dados. (Default: localhost)
* `process.env.PGPORT`: (int) Porta do postgresql. (Default: 5432)
* `process.env.PGUSER`: (string) Nome do usuário de acesso ao postgresql. (Default: xcontact)
* `process.env.PGPASS`: (string) Senha do usuário de acesso ao postgresql.
* `process.env.PGDB`: (string) Nome da base de dados. (Default: xcontact)
* `process.env.XCLOG_LEVEL`: (string) Level do Log, aceita: trace, debug, info, warn, error and fatal. (Default: error)
* `process.env.XCLOG_FILE`:  (string) caminho do arquivo de log. (Defaul: /var/log/xcontact.log)

## Uso
Exemplo de uso de model e util em um unico import.

```js
process.env.PGHOST = '1.2.3.4';
process.env.PGPASS = 'senha_do_postgres';

const { models, util } = require('xcontact-lib');

util.log.setLevel('debug');
util.log.info('Opa, dae!');

async function run() {
    const agentes = await models.Agente.fetch();
    console.log(agentes);
}

run();

```

## Uso 2
Exemplo de uso com import individual.

```js
process.env.PGHOST = '1.2.3.4';
process.env.PGPASS = 'senha_do_postgres';

const Agente = require('xcontact-lib/models/Agente');

async function run() {
    const agentes = await Agente.fetch();
    console.log(agentes);
}

run();
```
