// Pega o .env do projeto se tiver
require('dotenv').config()
const fs = require('fs')

const tabela = process.argv[2]
const modelo = process.argv[3]

const db = require('./util/db')

const Tipos = new Map()
Tipos.set('character varying', 'string')
Tipos.set('timestamp without time zone', 'dateTime')
Tipos.set('timestamp with time zone', 'dateTime')
Tipos.set('bigint', 'decimal')
Tipos.set('integer[]','object')
Tipos.set('ARRAY','object')
Tipos.set('timestamp with time zone', 'dateTime')
Tipos.set('time without time zone', 'time')

function getTipo(tipo) {
  return Tipos.has(tipo) ? Tipos.get(tipo) : tipo
}

async function run() {
  const colunas = await db.orm.Query.prototype.execute(`SELECT column_name as coluna, data_type as tipo FROM information_schema.columns WHERE table_name = '${tabela}';`)
  const pkey = await db.orm.Query.prototype.execute(`SELECT c.column_name as pkey
FROM information_schema.table_constraints tc 
JOIN information_schema.constraint_column_usage AS ccu USING (constraint_schema, constraint_name) 
LEFT JOIN information_schema.columns AS c ON c.table_schema = tc.constraint_schema
  AND tc.table_name = c.table_name AND ccu.column_name = c.column_name
WHERE constraint_type = 'PRIMARY KEY' and tc.table_name = '${tabela}';`)

  const lines = {}
  colunas.forEach(col => {
    if (pkey && pkey.length > 0 && pkey[0].pkey === col.coluna) {
      lines[col.coluna] = { type: getTipo(col.tipo), primary: true, updated: false, methods: true }
    } else {
      lines[col.coluna] = getTipo(col.tipo)
    }
  })

  const m = `
const db = require('../util/db')

class ${modelo} extends db.orm.Model { }

${modelo}.table = "${tabela}"

${modelo}.fields = ${JSON.stringify(lines, null, 2)}

module.exports = ${modelo};
`

  try {
    fs.writeFileSync(`./models/${modelo}.js`, m)
    console.log(`Modelo gerado em models/${modelo}.js`)
  } catch (err) {
    console.error(err)
  }
}

run()
