const db = require('../util/db');
const AutenticacaoFontes = require('./AutenticacaoFontes');

class Agente extends db.orm.Model { }

Agente.table = 'agentes';
Agente.fields = {
    id: { type: 'integer', primary: true, updated: false, methods: true },
    nome: 'string',
    senha: 'string',
    ramal: 'string',
    fullname: { type: 'string', unique: true, methods: true },
    status: 'integer',
    datastatus: 'dateTime',
    modo: 'string',
    max_chat_atende: 'integer',
    assinatura: 'text',
    edita_rota: 'boolean',
    visualiza_todos_clientes: 'boolean',
    atalho_url: `string`,
    abrir_url: `boolean`,
    tempo_maximo_sessao: `decimal`,
    tempo_auto_pausa: `decimal`,
    edita_config: 'boolean',
    auto_atendimento: 'boolean',
    auto_atendimento_omni: 'boolean',
    assinatura_na_mensagem: 'boolean',
    classificacoes_por_fila: 'boolean',
    default_instance: 'string',
    pode_selecionar_instancias: 'boolean',
    editaCliente: 'boolean',
    editaClienteGrupo: 'boolean',
    timerClassificacao: 'integer',
    autenticacao_fonte: {
        type: 'integer',
        column: 'autenticacao_fonte',
        references: AutenticacaoFontes.fields.id
    },
    profileImage: 'string'
}

module.exports = Agente;