const db = require("../util/db");
const Fila = require("./Fila");

class Campanha extends db.orm.Model { };

Campanha.table = "campanhas";

Campanha.fields = {
    id: { type: "string", primary: true, updated: false, methods: true },
    nome: { type: "string" },
    modo: { type: "string" },
    status: { type: "string" },
    data_ini: { type: "dateTime" },
    data_fim: { type: "dateTime" },
    data_status: { type: "dateTime" },
    data_start: { type: "dateTime" },
    data_create: { type: "dateTime" },
    tentativas: { type: "integer" },
    max_por_agente: { type: "integer" },
    max_chamar: { type: "integer" },
    autofim: { type: "boolean" },
    descricao: { type: "string" },
    falhas: { type: "integer" },
    mas_simultaneas_campanha: { type: "integer" },
    rota: { type: "string" },
    tempo_minimo_completar: { type: "integer" },
    tempo_autopausa_agente: { type: "integer" },
    desconecta_multiplas: { type: "boolean" },
    id_layout: { type: "integer" },
    fila: { type: "string", references: Fila.fields.name },
    processamento: { type: "string" },
    macro: { type: "string" },
    requer_agente_online: { type: "boolean" },
    notificar_final: { type: "boolean" },
    notificar_email: { type: "string" },
    exec_contexto: { type: "string" },
    intervalo_minimo_tentativa: { type: "integer" },
    tipo_campanha: { type: "integer" },
    turnos: { type: "array" },
    intervalo_entre_mensagens: { type: "integer" },
    ddi_padrao: { type: "string" },
    texto_padrao_campanha: { type: "string" },
    caminho_imagem_campanha: { type: "string" },
    legenda_imagem_campanha: { type: "string" },
    caminho_arquivo_campanha: { type: "string" },
};

module.exports = Campanha;
