const db = require('../util/db');
const ClienteGrupo = require('./ClienteGrupo');

const request = require('request');
const fs = require('fs');
const log = require("../util/Log");
class Cliente extends db.orm.Model { }

Cliente.downloadImage = (url, name = 'perfil.jpg', remetente) => {
    try {
        var dir = `/var/www/html/clientes/${remetente}`;
        var stream = function () {
            fs.mkdirSync(dir, { recursive: true });
            request(url)
                .pipe(fs.createWriteStream(`${dir}/perfil.jpg`))
                .on("error", (error) => {
                    console.error(error);
                    console.trace(error);
                    log.error(`[Socket-Server-ModelsClienteDownloadImage-Error] Erro! ` + error);
                });
        }
        stream();
        return dir + '/perfil.jpg';
    } catch (error) {
        console.error('ERRRO AO BAIXAR IMAGEM DO WHATS');
    }
}
Cliente.downloadImageNew = (url, cliente) => {
    try {
        var dir = `/gravacoes/clientes`;
        var stream = function () {
            fs.mkdirSync(dir, { recursive: true });
            const req = request
                .get(url)
                .on('response', function (res) {
                    if (res.statusCode === 200) {
                        req.pipe(fs.createWriteStream(`${dir}/${cliente.id}.jpg`))
                    } else {
                        log.error(`ERRO AO BAIXAR IMAGEM`, res);
                    }
                })
        }
        stream();
        return `${dir}/${cliente.id}.jpg`;
    } catch (error) {
        log.error('ERRRO AO BAIXAR IMAGEM DO WHATS');
    }
}
Cliente.getClienteCall = async (msg) => {
    msg.idCliente = msg.remetente;
    try {
        if (msg.idCliente.length === 11) {
            var num = msg.idCliente.substring(3);
            var cliente = await Cliente.query.require(true).first()
                .where(Cliente.where.like({ numero: `%${num}` }))
                .fetch();
            return cliente;
        } else if (msg.idCliente.length === 13) {
            var num = msg.idCliente.substring(5);
            var cliente = await Cliente.query.require(true).first()
                .where(Cliente.where.like({ numero: `%${num}` }))
                .fetch();
            return cliente;
        } else {
            var cliente = await Cliente.query.require(true).first()
                .where(Cliente.where.like({ numero: `%${msg.idCliente}` }))
                .fetch();
            return cliente;
        }
    } catch (error) {
        var cliente = await Cliente.fetchById(9999999);
        return cliente;
    }
}
/**
 * Retorna o cliente cadasreado na base pelo número contido na msg no atributo idCliente.
 * Se não encontrar cadastra e retorna o que cadastrou.
 */
Cliente.getClientFromMsg = async (msg) => {
    //const NumerosAdicionais = require(`./ClienteNumerosAdicionais`);
    msg.idGrupo = msg.idGrupo ? parseInt(msg.idGrupo) : null;
    try {
        var num = msg.idCliente.substr(-8);
        var cliente = await Cliente.query.require(true).first()
            .where(Cliente.where.like({ numero: `%${num}` }))
            .fetch();
        cliente.numero = msg.idCliente;
        cliente.save();
        return cliente;
    } catch (error) {
        console.error(error);
        return await new Cliente({ numero: msg.idCliente, isBusiness: false, nome: msg.nomeCliente, idGrupo: msg.idGrupo }).save();
    }
}
Cliente.getClienteByEmail = async (msg) => {
    try {
        return await Cliente.fetchByEmail(msg.idCliente);
    } catch (error) {
        if (msg.numero) {
            let msgAux = msg;
            msgAux.idCliente = msgAux.numero;
            return await Cliente.getClientFromMsg(msgAux);
        }
        return await new Cliente({ numero: null, isBusiness: false, nome: msg.name, profileImage: null, email: msg.idCliente }).save();

    }
}

Cliente.getClienteByMsg = async (msg) => {
    msg.idCliente = msg.from;
    msg.nomeCliente = msg.name;
    try {
        var cliente = (msg.queueTypeID === 3 || msg.queueTypeID === 5) ? await Cliente.getClientFromMsg(msg) : await Cliente.getClienteByEmail(msg);
        if (cliente) {
            if (msg.queueTypeID === 3) {
                if (msg.image !== null) cliente.profileImage = await Cliente.downloadImageNew(msg.image, cliente);
            }
            return await new Cliente({ id: cliente.id, numero: cliente.numero, isBusiness: msg.isBusiness, email: cliente.email, documento: cliente.documento, profileImage: cliente.profileImage, idGrupo: cliente.idGrupo ? cliente.idGrupo : null }).save();
        }
        // if (msg.queueTypeID === 3 || msg.queueTypeID === 5) {
        //     if (!cliente) return await new Cliente({ numero: null, isBusiness: false, nome: msg.nomeCliente, profileImage: null, numero: msg.idCliente }).save();
        // }

    } catch (err) {
        //log.error(err);
    }
}

Cliente.table = 'cliente';
Cliente.fields = {
    id: { type: 'integer', primary: true, updated: false, methods: true },
    numero: { type: 'string', unique: true, methods: true },
    isBusiness: 'boolean',
    nome: { type: 'string' },
    documento: { type: 'string' },
    profileImage: 'string',
    idGrupo: {
        type: 'integer',
        references: ClienteGrupo.fields.id
    },
    url: { type: `string` },
    email: { type: 'string', unique: true, methods: true }
}

module.exports = Cliente;