const db = require('../util/db');
const Pesquisa = require('./Pesquisa');

class Fila extends db.orm.Model {}

Fila.table = 'queue_table';
Fila.fields = {
    name: { type: 'string', primary: true, updated: false, methods: true },
    id: { type: 'integer', methods: true },
    musiconhold: 'string',
    announce: 'string',
    context: 'string',
    timeout: 'integer',
    monitor_join: 'boolean',
    monitor_format: 'string',
    queue_youarenext: 'string',
    queue_thereare: 'string',
    queue_callswaiting: 'string',
    queue_holdtime: 'string',
    queue_minutes: 'string',
    queue_seconds: 'string',
    queue_lessthan: 'string',
    queue_thankyou: 'string',
    queue_reporthold: 'string',
    announce_frequency: 'integer',
    announce_round_seconds: 'integer',
    announce_holdtime: 'string',
    retry: 'integer',
    wrapuptime: 'integer',
    maxlen: 'integer',
    servicelevel: 'integer',
    strategy: 'string',
    joinempty: 'string',
    leavewhenempty: 'string',
    eventmemberstatus: 'boolean',
    eventwhencalled: 'boolean',
    reportholdtime: 'boolean',
    memberdelay: 'integer',
    weight: 'integer',
    timeoutrestart: 'boolean',
    setinterfacevar: 'boolean',
    ringinuse: 'integer',
    nivel_percentual: 'integer',
    nivel_tempo: 'integer',
    numero: 'integer',
    nivel_abandono_tempo: 'integer',
    nivel_abandono_percentual: 'integer',
    id_calculo_nivel: 'integer',
    queue_type: 'integer',
    autofill: 'string',
    autopause: 'string',
    id_calculo_performance: 'integer',
    setqueuevar: 'boolean',
    verificaFeriado: 'boolean',
    emailConfig: 'json',
    obrigaClassificar: 'boolean',
    PesquisaID: {
        column: 'id_pesquisa', 
        type: 'integer',      
        references: Pesquisa.fields.id
    },
}

module.exports = Fila;






  