const db = require('../util/db');
const DateUtil = require('../util/DateTime');

class UraFluxo extends db.orm.Model { }

UraFluxo.table = 'ura_fluxo';
UraFluxo.fields = {
    seq: { type: 'integer', primary: true, updated: false, methods: true },
    callid: 'string',
    calldate: "dateTime",
    src: 'string',
    dst: 'string',
    context: 'string',
    menu: 'string',
    id_client: 'string',
    opcao: 'string',
    src_menu: 'string',
    data_a: 'string',
    data_b: 'string',
};
UraFluxo.virtuals = {
    data: {
        type: 'date',
        get() {
            return DateUtil.onlyDateEn(this.calldate);
        }
    },
    hora: {
        get() {
            return DateUtil.onlyTime(this.calldate);
        }
    }
};

module.exports = UraFluxo;