const { knorm } = require('@knorm/knorm');
const { knormPostgres } = require('@knorm/postgres');
const { knormRelations } = require('@knorm/relations');
const { knormPaginate } = require('@knorm/paginate');

const connection = {
    host: process.env.PGHOST || 'localhost',
    port: process.env.PGPORT || 5432,
    user: process.env.PGUSER || 'xcontact',
    password: process.env.PGPASS,
    database: process.env.PGDB || 'xcontact',
};

exports.orm = knorm().use(knormPostgres({ connection })).use(knormRelations()).use(knormPaginate());