const os = require("os");
const log = require('./Log');

if (os.platform() != "win32") {
    // Define all events to register on the process
    const haltEvents = [
        `SIGINT`, `SIGQUIT`, `SIGHUP`, `SIGUSR2`, `SIGTERM`, `uncaughtException`
        /* `exit`, */ /* `unhandledRejection`, */
    ];

    function onProcessHalt() {
        try {
            console.error(`\n\nProcesso do XCONTACT encerrado!\n\n`, arguments);
            log.error(`[DEFAULT_ERROR_CATCHER] Processo do xcontact recebeu -> ` + JSON.stringify(arguments));
        } catch (e) {
            console.trace(e);
            log.error(`[DEFAULT_ERROR_CATCHER] Erro ao mostrar log -> ` + e);
        }

        process.exitCode = 1;
        process.exit();
    }

    // Register hooks on the process
    haltEvents.forEach(event => {
        process.on(event, onProcessHalt.bind(this, event));
    });
}