const { ami } = require('../../../index')
const moment = require('moment');
const log = require("node-live-log")("online/Eventos/Omni/handlers");
const _ = require('underscore')

exports.filaAddAtendimento = async (io, ev) => {
  log.debug('[filaAddAtendimento]', ev)
    const fila = ev.fila
    const filaOld = ev.filaOld
    const evento = {
      data: ev.data,
      fila: fila,
      sentido: ev.sentido,
      AtendimentoId: ev.atendimentoId,
      numero: ev.numero,
      nome: ev.nome,
      filaOld: filaOld
    }
    const filaAmi = ami.filas.find(f => f.name === fila)
    
    if (filaAmi) {
        const atendimentoExistente = filaAmi.AtendimentosAguardando.find(at => at.AtendimentoId === ev.atendimentoId)
        if (atendimentoExistente) return
        evento.posicaoInicial = filaAmi.AtendimentosAguardando.length + 1
        if (ev.numero) {
          filaAmi.clientes_atendidos.push(ev.numero)
        }
        filaAmi.clientes_atendidos = _.uniq(filaAmi.clientes_atendidos)
        filaAmi.AtendimentosAguardando.push(evento)
        if (!filaAmi.idEntrante.includes(ev.atendimentoId)) {
          filaAmi.TotalAtendimentosEntrantes++
          filaAmi.idEntrante.push(ev.atendimentoId)
          filaAmi.obj_atendimentos.push(evento)
        }
        if (ev.filaOld) {
          const filaAmiOld = ami.filas.find(f => f.name === filaOld)
          if (ev.sentido === 'Sainte') {
            if (filaAmiOld.TotalAtendimentosSaintes > 0) {
              filaAmiOld.TotalAtendimentosSaintes--
            }
          } else {
            if (filaAmiOld.idEntrante.includes(ev.atendimentoId)){
            filaAmiOld.TotalAtendimentosEntrantes--
          }
          }
        }
    }

    io.to(`fila_${fila}`).emit('FilaAtendimentoAguardandoAdicionado', evento)
}

exports.removeAtendimentoNaFila = async (io, ev) => {
  log.debug('[removeAtendimentoNaFila]', ev)
    const fila = ev.fila
    const filaNew = ev.filaNew
    const filaAmi = ami.filas.find(f => f.name === fila)
    const filaNewAmi = ami.filas.find(f => f.name === filaNew)
    if (filaAmi) {
      let evento = {
        data: ev.data,
        fila: fila,
        sentido: 'Entrante',
        AtendimentoId: ev.atendimentoId,
        agente: ev.agente,
        nome: ev.nome,
        numero: ev.numero,
        tipo: ev.tipo,
        filaNew: filaNew,
        agenteNew: ev.agenteNew,
      }
      const agente = filaAmi.agentes.find(agente => agente.nome === ev.agente);
      if (ev.tipo === 'atendido') {
        
        const atIndex = filaAmi.AtendimentosAguardando.findIndex((at) => at.AtendimentoId === ev.atendimentoId)
        if (atIndex !== -1) {
          filaAmi.AtendimentosAguardando.splice(atIndex, 1)
        }

        const ultimaMensagem = { data: moment().format('DD/MM/YYYY HH:mm:ss'), sentido: 'entrante' }
        evento.ultimaMensagem = ultimaMensagem
        evento.primeira_resposta = true
        const indexAtendimento = filaAmi.AtendimentosEmAndamento.findIndex(
          (at) => at.AtendimentoId === ev.atendimentoId
        )
        if (indexAtendimento === -1) {
          
          filaAmi.AtendimentosEmAndamento.push(evento)
          if (filaAmi.idEntrante && !filaAmi.idEntrante.includes(ev.atendimentoId)) {
            filaAmi.TotalAtendimentosEntrantes++
            filaAmi.idEntrante.push(ev.atendimentoId)
            filaAmi.obj_atendimentos.push(evento)
          }
        }
        if (agente) {
          const indexAtendimentoAgente = agente.atendimento_ativo.findIndex(
            (at) => at.AtendimentoId === ev.atendimentoId
          )
          if (indexAtendimentoAgente === -1) {
            agente.atendimento_ativo.push(evento)
            agente.atendimentos_recebidos++
          }
        }
          
        io.to(`fila_${fila}`).emit('FilaAtendimentoAguardandoRemovido', evento)
      }
      if (ev.tipo === 'encerramento') {
        filaAmi.TotalAtendimentosEncerrados++
        const index = filaAmi.AtendimentosEmAndamento.findIndex(
          (at) => at.AtendimentoId === ev.atendimentoId
        )
        if (index !== -1) {
          filaAmi.AtendimentosEmAndamento.splice(index, 1)
        }
        const atIndex = filaAmi.AtendimentosAguardando.findIndex((at) => at.AtendimentoId === ev.atendimentoId)
        if (atIndex !== -1) {
          filaAmi.AtendimentosAguardando.splice(atIndex, 1)
        }
        if (agente) {
          const indexAgente = agente.atendimento_ativo.findIndex(
            (at) => at.AtendimentoId === ev.atendimentoId
          )
          if (indexAgente !== -1) {
            agente.atendimento_ativo.splice(indexAgente, 1)
          }
        }
        
        if (filaAmi.idEntrante.includes(ev.atendimentoId)) {
          filaAmi.idEntrante.splice(filaAmi.idEntrante.indexOf(ev.atendimentoId), 1)
        }
        
        io.to(`fila_${fila}`).emit('FilaAtendimentoEncerrado', evento)
      }
      if (ev.tipo === 'transferencia') {
        filaAmi.TotalAtendimentosEncerrados++
        const atIndex = filaAmi.AtendimentosAguardando.findIndex((at) => at.AtendimentoId === ev.atendimentoId)
        if (atIndex !== -1) {
          filaAmi.AtendimentosAguardando.splice(atIndex, 1)
        }
        const atendimento = filaAmi.AtendimentosEmAndamento.find(
          (at) => at.AtendimentoId === ev.atendimentoId
        )
        
        if (atendimento) {
          if (filaNewAmi) {
            const index = filaAmi.AtendimentosEmAndamento.findIndex(
              (at) => at.AtendimentoId === ev.atendimentoId
            )
            if (index !== -1) {
              filaAmi.AtendimentosEmAndamento.splice(index, 1)
            }
            
            if (agente) {
              const indexAgente = agente.atendimento_ativo.findIndex(
                (at) => at.AtendimentoId === ev.atendimentoId
              )
              if (indexAgente !== -1) {
                agente.atendimento_ativo.splice(indexAgente, 1)
              }
            }

            atendimento.fila = filaNewAmi.name
            const idIndex = filaNewAmi.idEntrante.findIndex((id) => id === ev.atendimentoId)
            if (idIndex !== -1) {
              filaNewAmi.idEntrante.splice(idIndex, 1)
            }
            
          }

          if (agente && ev.agenteNew) {
            atendimento.agente = ev.agenteNew
            if (filaNewAmi) {
              const agenteFilaNew = filaNewAmi.agentes.find(agente => agente.nome === ev.agente)
              const indexAgente = agenteFilaNew.atendimento_ativo.findIndex(
                (at) => at.AtendimentoId === ev.atendimentoId
              )
              if (indexAgente !== -1) {
                agenteFilaNew.atendimento_ativo.splice(indexAgente, 1)
              }
            
              const agenteNewFilaNew = filaNewAmi.agentes.find(agente => agente.nome === ev.agenteNew)
              agenteNewFilaNew.atendimentos_recebidos++
              agenteNewFilaNew.atendimento_ativo.push(atendimento)
              filaNewAmi.AtendimentosEmAndamento.push(atendimento)
              filaNewAmi.idEntrante.push(ev.atendimentoId)
              filaNewAmi.obj_atendimentos.push(atendimento)
              filaNewAmi.TotalAtendimentosEntrantes++

              if (atendimento.sentido === 'Sainte') {
                filaAmi.TotalAtendimentosSaintes--
              } else {
                filaAmi.TotalAtendimentosEntrantes--
              }
            } else {
              if (agente) {
                const indexAgente = agente.atendimento_ativo.findIndex(
                  (at) => at.AtendimentoId === ev.atendimentoId
                )
                if (indexAgente !== -1) {
                  agente.atendimento_ativo.splice(indexAgente, 1)
                }
              }
              const agenteNew = filaAmi.agentes.find(agente => agente.nome === ev.agenteNew)
              agenteNew.atendimentos_recebidos++
              agenteNew.atendimento_ativo.push(atendimento)
            }
          }
        }
        
        if (filaAmi.idEntrante.includes(ev.atendimentoId)) {
          filaAmi.idEntrante.splice(filaAmi.idEntrante.indexOf(ev.atendimentoId), 1)
        }
        
        io.to(`fila_${fila}`).emit('FilaAtendimentoEncerrado', evento)

        // if (ev.tipo === 'transferencia' && ev.transferTo) {
        //   const evento = {
        //     fila: ev.transferTo,
        //     sentido: 'Entrante',
        //     AtendimentoId: ev.atendimentoId,
        //   }
        // filaAmi.TotalAtendimentosEntrantes++
        // // agente.atendimentos_recebidos++
        // io.to(`fila_${ev.transferTo}`).emit('FilaNovoAtendimento', evento)
        // }
      }
      if (ev.tipo === 'transbordo') {
        const filaOld = ev.filaOld
        const filaOldAmi = ami.filas.find(f => f.name === filaOld)

        evento.filaOld = filaOld
        if (filaOldAmi) {
          filaOldAmi.TotalAtendimentosTransbordados++
          const atendimento = filaOldAmi.AtendimentosAguardando.find(
            (at) => at.AtendimentoId === ev.atendimentoId
          )
          const index = filaOldAmi.AtendimentosEmAndamento.findIndex(
          (at) => at.AtendimentoId === ev.atendimentoId
        )
        if (index !== -1) {
          filaOldAmi.AtendimentosEmAndamento.splice(index, 1)
        }
          filaAmi.AtendimentosAguardando.push(atendimento)

          io.to(`fila_${fila}`).emit('FilaAtendimentoTransbordado', evento)
        }
      }
    }
}

exports.novaMensagemAgente = async (io, ev) => {
  log.debug('[novaMensagemAgente]', ev)
    const fila = ev.fila
    const evento = {
        data: ev.data,
        fila: fila,
        sentido: ev.tipo,
        AtendimentoId: ev.atendimentoId,
        agente: ev.agente,
        nome: ev.nome,
        subtipo: ev.subtipo
    }

    const filaAmi = ami.filas.find(f => f.name === fila)
    if (filaAmi) {
        const agente = filaAmi.agentes.find(agente => agente.nome === ev.agente);
        let atendimento = filaAmi.AtendimentosEmAndamento.find(
          (at) => at.AtendimentoId === ev.atendimentoId
        )
        if (agente) {
          let agenteAtendimento = agente.atendimento_ativo.find(
            (at) => at.AtendimentoId === ev.atendimentoId)
          if (atendimento) {
            if (ev.tipo === 'sainte') filaAmi.MsgEnviadas++
            else filaAmi.MsgRecebidas++
          }
          if (atendimento.ultimaMensagem && atendimento.ultimaMensagem.sentido === 'entrante' && ev.tipo === 'sainte') {
            if (atendimento.primeira_resposta) {
              const tempoResposta = moment().diff(
                moment(atendimento.data),
                'seconds'
              )
                agenteAtendimento.primeira_resposta = false
                agente.tempo_primeira_resposta += tempoResposta
                agente.total_primeira_resposta++
                agente.tempo_total_resposta += tempoResposta
                agente.total_mensagens_resposta++
              if (tempoResposta > filaAmi.tmaxr) {
                agente.tmaxr = tempoResposta
              }
              if (tempoResposta > filaAmi.tmaxpr) {
                agente.tmaxpr = tempoResposta;
              } 
            } else if (atendimento.ultimaMensagem) {
              const tempoResposta = moment().diff(
                 moment(atendimento.ultimaMensagem.data, 'DD/MM/YYYY HH:mm:ss'),
                'seconds'
              )
              agente.tempo_total_resposta += tempoResposta
              agente.total_mensagens_resposta++
              if (tempoResposta > filaAmi.tmaxr) {
                agente.tmaxr = tempoResposta
              }
            }
          }
          agenteAtendimento.ultimaMensagem = {
            sentido: ev.tipo,
            data: moment().format('DD/MM/YYYY HH:mm:ss'),
          }
        }
        if (atendimento.ultimaMensagem && atendimento.ultimaMensagem.sentido === 'entrante' && ev.tipo === 'sainte') {
          if (atendimento.primeira_resposta) {
            const tempoResposta = moment().diff(
              moment(atendimento.data),
              'seconds'
            )
            atendimento.primeira_resposta = false
            filaAmi.tempo_primeira_resposta += tempoResposta
            filaAmi.total_primeira_resposta++
            filaAmi.tempo_total_resposta += tempoResposta
            filaAmi.total_mensagens_resposta++
            if (tempoResposta > filaAmi.tmaxr) {
              filaAmi.tmaxr = tempoResposta
            }
            if (tempoResposta > filaAmi.tmaxpr) {
              filaAmi.tmaxpr = tempoResposta;
            } 

          } else {
            if (atendimento.ultimaMensagem) {
              const tempoResposta = moment().diff(
                moment(atendimento.ultimaMensagem.data, 'DD/MM/YYYY HH:mm:ss'),
                'seconds'
              )
              filaAmi.tempo_total_resposta += tempoResposta
              filaAmi.total_mensagens_resposta++
              if (tempoResposta > filaAmi.tmaxr) {
                filaAmi.tmaxr = tempoResposta
              }
            }
          }
        }
        if (atendimento.ultimaMensagem) {
          atendimento.ultimaMensagem = {
            sentido: ev.tipo,
            data: moment().format('DD/MM/YYYY HH:mm:ss'),
          }
        }
    }

    io.to(`fila_${fila}`).emit('FilaNovaMensagem', evento)
}

exports.filaNovaMensagem = async (io, ev) => {
  log.debug('[filaNovaMensagem]', ev)
    const fila = ev.fila
    const evento = {
        data: ev.data,
        fila: fila,
        sentido: 'entrante',
        AtendimentoId: ev.atendimentoId,
        agente: ev.agente,
        nome: ev.nome
    }

    const filaAmi = ami.filas.find(f => f.name === fila)
    if (filaAmi) {
        let atendimento = filaAmi.AtendimentosEmAndamento.find(
            (at) => at.AtendimentoId === ev.atendimentoId)
        if (atendimento) {
          if (atendimento.ultimaMensagem) {
            atendimento.ultimaMensagem = {
              sentido: 'entrante',
              data: moment().format('DD/MM/YYYY HH:mm:ss'),
            }
          }
          filaAmi.MsgRecebidas++
        }
        const agente = filaAmi.agentes.find(agente => agente.nome === ev.agente)
        if (agente) {
          let agenteAtendimento = agente.atendimento_ativo.find(
          (at) => at.AtendimentoId === ev.atendimentoId)
          if (agenteAtendimento) {
            if (agenteAtendimento.ultimaMensagem) {
              agenteAtendimento.ultimaMensagem = {
                sentido: 'entrante',
                data: moment().format('DD/MM/YYYY HH:mm:ss'),
              }
            }
          }
        }
        
    }

    io.to(`fila_${fila}`).emit('FilaNovaMensagem', evento)
}

exports.filaNovoAtendimento = async (io, ev) => {
  log.debug('[filaNovoAtendimento]', ev)
    const fila = ev.fila
    const filaOld = ev.filaOld
    const evento = {
        data: ev.data,
        fila: fila,
        sentido: 'Entrante',
        AtendimentoId: ev.atendimentoId,
        numero: ev.numero,
        nome: ev.nome,
        filaOld: filaOld
    }

    const filaAmi = ami.filas.find(f => f.name === fila)
    const filaOldAmi = ami.filas.find(f => f.name === filaOld)
    if (filaAmi) {
        if (!filaAmi.idEntrante.includes(ev.atendimentoId)) {
          filaAmi.TotalAtendimentosEntrantes++
          filaAmi.idEntrante.push(ev.atendimentoId)
          filaAmi.obj_atendimentos.push(evento)
        }
        if (ev.numero) {
          filaAmi.clientes_atendidos.push(ev.numero)
        }
        filaAmi.clientes_atendidos = _.uniq(filaAmi.clientes_atendidos)
    }
    if (filaOldAmi && filaOldAmi.idEntrante.includes(ev.atendimentoId)) {
      filaOldAmi.TotalAtendimentosEntrantes--
    }

    io.to(`fila_${fila}`).emit('FilaNovoAtendimento', evento)
}

exports.agenteAddAtendimento = async (io, ev) => {
  log.debug('[agenteAddAtendimento]', ev)
    const fila = ev.fila
    const evento = {
        data: ev.data,
        fila: fila,
        sentido: 'Sainte',
        AtendimentoId: ev.atendimentoId,
        agente: ev.agente,
        numero: ev.numero,
        nome: ev.nome
    }

    const filaAmi = ami.filas.find(f => f.name === fila)
    if (filaAmi) {
      const agente = filaAmi.agentes.find(agente => agente.nome === ev.agente);
      if (ev.numero) {
          filaAmi.clientes_atendidos.push(ev.numero)
        }
        filaAmi.clientes_atendidos = _.uniq(filaAmi.clientes_atendidos)

        filaAmi.TotalAtendimentosSaintes++
        filaAmi.obj_atendimentos.push(evento)
        const ultimaMensagem = { data: moment().format('DD/MM/YYYY HH:mm:ss'), sentido: 'sainte' }
        evento.ultimaMensagem = ultimaMensagem
        evento.primeira_resposta = false
        filaAmi.AtendimentosEmAndamento.push(evento)
        if (agente) {
          agente.atendimentos_efetuados++
        //   await ami.addAgente(fila, { name: ev.agente, status: 999 })
          agente.atendimento_ativo.push(evento)
        }
    }
    io.to(`fila_${fila}`).emit('FilaNovoAtendimento', evento)
}

exports.addAtendimentoCampanhaNaFila = async (io, ev) => {
  log.debug('[addAtendimentoCampanhaNaFila]', ev)
    const fila = ev.fila
    const evento = {
        data: ev.data,
        fila: fila,
        sentido: 'Sainte',
        AtendimentoId: ev.atendimentoId,
        numero: ev.numero,
        nome: ev.nome,
        status: ev.status,
    }

    const filaAmi = ami.filas.find(f => f.name === fila)
    if (filaAmi) {
        filaAmi.TotalAtendimentosSaintes++
        filaAmi.obj_atendimentos.push(evento)
        if (ev.numero) {
          filaAmi.clientes_atendidos.push(ev.numero)
        }
        filaAmi.clientes_atendidos = _.uniq(filaAmi.clientes_atendidos)
    }

    io.to(`fila_${fila}`).emit('addAtendimentoCampanhaNaFila', evento)
}