/**
 * Modulo que recebe eventos de outros serviços e publica para os agentes/supervisores
 */
const { MethodRoute, EventRoute } = require('ioroute')
const log = require("node-live-log")("online/index");
module.exports = class Online {
    constructor(io) {
        this.io = io
    }
    async start() {
        log.info('[Online] serviço do online iniciado')
        const onlinews = this.io.of('/online')
        const methodRoute = new MethodRoute()
        await methodRoute.register('online/Metodos')


        onlinews.on('connection', async (socket) => {
            log.info(`[Online] Nova conexao, IP: ${socket.handshake.address}, SocketID: ${socket.id}`)
            methodRoute.start(socket)

            const eventRouter = new EventRoute()
            await eventRouter.register('online/Eventos')
            eventRouter.start(this.io, socket)    
        })
    }
}