const readline = require('readline');
const xserver = process.argv[2] ? process.argv[2] : "http://localhost:3000/online";

// Apenas para fins de teste
const rl = readline.createInterface({
    input: process.stdin,
    output: process.stdout,
    prompt: 'Online CLI> '
})


const client = require("socket.io-client")(xserver, {
    "rejectUnauthorized": false
})

client.on('connect', () => {
    console.log('Parece que conectou')

    client.emit('login', { token: 'sdfrf89hwe4983hrdslkfh34809y5r' }, resposta => {
        console.log(`Login resposta: ${JSON.stringify(resposta)}`)
        if (resposta.error) {
            console.log(`Verifique os dados de acesso`)
        }
        else {
            // Login ok
            console.log('Dae sim...logado')
            rl.prompt()
        }
    });

});

client.on('disconnect', (e) => {
    console.log(e);
    console.log('Desconectou do servidor');
});

client.on('connect_timeout', (timeout) => {
    console.log('Desconectado, connection timeout.');
});
client.on('error', (error) => {
    console.log('Desculpe, algo deu errado.');
    console.log(error);
});
client.on('connect_error', (error) => {
    console.log('Erro de conexão. Tem certeza que o serviço do Xcontact está ativo?');
    console.log(error);
});
client.on('reconnecting', (attemptNumber) => {
    console.log(`Estou tentando reconectar. Tentativa: ${attemptNumber}`);
});
client.on('reconnect_failed', () => {
    console.log('Não estou conseguindo reconectar. Tem certeza que o serviço do Xcontact está ativo?');
});
client.on('unauthorized', (err) => {
    console.log("Falha na autenticação:", err.message);
});

rl.on('line', (line) => {
    let pars = line.trim().split(' ');

    switch (pars[0]) {
        case 'sair':
        case 'quit':
        case 'q':
            rl.close();
            break;
        case '':
            break;
        case 'debug':
            debugProcess();
            break;
        case 'NovoAtendimento':
            client.emit('NovoAtendimento', { fila: pars[1], dados: pars[2] }, resposta => {
                console.log(`NovoAtendimento resposta: ${JSON.stringify(resposta, null, 2)}`);
                rl.prompt();
            });
            break;
        case 'novaMensagem':
            client.emit('novaMensagemAgente', { fila: pars[1], dados: pars[2] }, resposta => {
                console.log(`novaMensagemAgente resposta: ${JSON.stringify(resposta, null, 2)}`);
                rl.prompt();
            });
            break;
        default:
            break;
    }
    rl.prompt();
}).on('close', () => {
    console.log('Até logo!');
    process.exit(0);
});