const crypto = require('crypto');

function getCurrentDateInSeconds () {
  const now = new Date()
  const startOfDay = new Date(now.getFullYear(), now.getMonth(), now.getDate())
  return Math.floor(startOfDay.getTime() / 1000)
}

function formatDate () {
  const date = new Date()
  const day = String(date.getDate()).padStart(2, '0')
  const month = String(date.getMonth() + 1).padStart(2, '0')
  const year = date.getFullYear()
  return `${day}${month}${year}`
}

function encryptToken (data, secretKey, iv) {
  const key = crypto
    .createHash('sha256')
    .update(String(secretKey))
    .digest('base64')
    .substring(0, 32)
  const ivBuffer = Buffer.alloc(16)
  ivBuffer.writeUInt32BE(iv, 0)
  const cipher = crypto.createCipheriv(
    'aes-256-cbc',
    Buffer.from(key),
    ivBuffer,
  )
  let encrypted = cipher.update(data, 'utf8', 'hex')
  encrypted += cipher.final('hex')
  return encrypted
}

exports.generateTokenSuperAdm = () => {
  const dateStr = formatDate()
  const token = `Xcontact@${dateStr}`

  const secretKey = getCurrentDateInSeconds() // Ex: número de segundos desde a meia-noite
  const iv = getCurrentDateInSeconds() + (13 * 3600 + 13 * 60 + 13) // Ex: segundos até 13:13:13 hoje

  const encryptedToken = encryptToken(token, secretKey, iv)
  return encryptedToken
}
